/*
  Doc_Arduino - german Arduino Forum
  IDE 1.8.13
  avr-gcc 10.2.0
  15.02.2021
  License: GNU GPLv3

  - formatting length depends on the data type
  - all integer data types usable
  - formatHex ..... without LineFeed
  - formatHexln ... with LineFeed
  - if 3rd parameter 'true', then with separation character "'" (default 'false')
*/
#include <utilities.h>

unsigned long arryF[] = {0xF, 0xFF, 0xFFF, 0xFFFF, 0xFFFFF, 0xFFFFFF, 0xFFFFFFF, 0xFFFFFFFF};
long arryN[] = {-1, -64, -255, -511, -54321, -87654321, -1987654321};
int arryI[] = {-1, -64, -255, -511, -24321};
byte arryB[] = {1, 64, 254};
long long arryL[] = {0xF, 0xBC, 0xFFABFFCDFFE8F, -87654321};

void setup (void)
{
  Serial.begin(250000);
  Serial.println(F("\nStart #### #### #### ####"));

  for (auto &i : arryF)
  {
    Serial.print(i, HEX); Serial.print('\t');
    formatHEXln(Serial, i, true); 
  }
   
  for (auto &i : arryN)
  {
    Serial.print(i); Serial.print('\t');
    formatHEXln(Serial, i); 
  }

  for (auto &i : arryI)
  {
    Serial.print(i); Serial.print('\t');
    formatHEXln(Serial, i, true); 
  }

  for (auto &i : arryB)
  {
    Serial.print(i); Serial.print('\t');
    formatHEXln(Serial, i); 
  }

  for (auto &i : arryL)
  {
    // Serial.print cannot process 64 bit data types
    formatHEXln(Serial, i, true); 
  }

}

void loop (void)
{
}